#!/bin/sh -e

##########################CONFIG#############################################
EMAIL=first.last@email.com
PWD=mybigsecret
IP=127.0.0.1
PORT=8080
IDX=112
TMPDIR=/tmp
##########################CONFIG#############################################

##########################URL################################################
URL_ID=https://im.gigaset-elements.de/identity/api/v1/user/login
URL_AUTH=https://api.gigaset-elements.de/api/v1/auth/openid/begin?op=gigaset
URL_BASE=https://api.gigaset-elements.de/api/v1/me/basestations
##########################URL################################################

echo
echo Gigaset Elements Modus Curl-Cli version 0.1
echo

MODUS="unset"
LEVEL="$(curl -s "http://$IP:$PORT/json.htm?type=devices&rid=$IDX" | jq '.result[0].Level' | tr -d "'")"

if test `find "$TMPDIR/gse_expire" -mmin +355`; then
  echo cookies older than 6 hours so deleting
  rm -f $TMPDIR/gse_cookies
fi

if [ ! -f $TMPDIR/gse_cookies ]; then
  echo [-] authenticating
  touch $TMPDIR/gse_expire
  curl -siSL --user-agent 'Mozilla/5.0' --insecure --cacert $TMPDIR/gse_expire --cookie $TMPDIR/gse_cookies --cookie-jar $TMPDIR/gse_cookies --data email=$EMAIL --data password=$PWD $URL_ID
  curl -siSL --user-agent 'Mozilla/5.0' --insecure --cacert $TMPDIR/gse_expire --cookie $TMPDIR/gse_cookies --cookie-jar $TMPDIR/gse_cookies -H "Accept: application/json" -H "Content-Type: application/json" -X GET $URL_AUTH
else
  echo "[-] pre-authenticated"
fi

MODUS="$(curl --insecure --cacert $TMPDIR/gse_expire -siSL --tlsv1 --ipv4 --user-agent 'Mozilla/5.0' --cookie $TMPDIR/gse_cookies --cookie-jar $TMPDIR/gse_cookies -H "Content-Type: application/json" -X GET $URL_BASE | sed -e 's/[{}]/''/g' |   awk -v k="text" '{n=split($0,a,","); for (i=1; i<=n; i++) print a[i]}' | grep active_mode | cut -d '"' -f6)"
echo "[-] current modus $MODUS"
echo "[-] current level $LEVEL"

if [ "$MODUS" = "home" -a $LEVEL != "0" ]; then
   ADJLEVEL=0

elif [ "$MODUS" = "custom" -a $LEVEL != "10" ]; then
   ADJLEVEL=10

elif [ "$MODUS" = "away" -a $LEVEL != "20" ]; then
   ADJLEVEL=20

else
   echo "[-] update of selector switch not needed"
   echo
   exit;
fi

echo "[-] settting selector switch to $MODUS (level $ADJLEVEL)"
curl -s "http://$IP:$PORT/json.htm?type=command&param=udevice&idx=$IDX&nvalue=1&svalue=$ADJLEVEL"
curl -s "http://$IP:$PORT/json.htm?type=command&param=addlogmessage&message=(Gigaset%20Elements)%20$MODUS%20Modus%20Detected%20(Gigaset%20Elements)"
echo
exit;